/*
BotV2

Bot API v2

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package botapiv2

import (
	"encoding/json"
)

// checks if the MessageData type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &MessageData{}

// MessageData struct for MessageData
type MessageData struct {
	// Id of text asset
	HeaderTextId *string `json:"header_text_id,omitempty"`
	// Id of text asset
	TextId *string `json:"text_id,omitempty"`
	// Id of text asset
	FooterTextId *string `json:"footer_text_id,omitempty"`
	// Id of template asset
	Template *string `json:"template,omitempty"`
	Media *MessageMedia `json:"media,omitempty"`
	Buttons []MessageButton `json:"buttons,omitempty"`
	List *MessageList `json:"list,omitempty"`
	// required for dynamic list - must match the key in script start list data
	ListName *string `json:"list_name,omitempty"`
	RequestLocation *MessageRequestLocation `json:"request_location,omitempty"`
	Cards []MessageData `json:"cards,omitempty"`
}

// NewMessageData instantiates a new MessageData object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewMessageData() *MessageData {
	this := MessageData{}
	return &this
}

// NewMessageDataWithDefaults instantiates a new MessageData object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewMessageDataWithDefaults() *MessageData {
	this := MessageData{}
	return &this
}

// GetHeaderTextId returns the HeaderTextId field value if set, zero value otherwise.
func (o *MessageData) GetHeaderTextId() string {
	if o == nil || IsNil(o.HeaderTextId) {
		var ret string
		return ret
	}
	return *o.HeaderTextId
}

// GetHeaderTextIdOk returns a tuple with the HeaderTextId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageData) GetHeaderTextIdOk() (*string, bool) {
	if o == nil || IsNil(o.HeaderTextId) {
		return nil, false
	}
	return o.HeaderTextId, true
}

// HasHeaderTextId returns a boolean if a field has been set.
func (o *MessageData) HasHeaderTextId() bool {
	if o != nil && !IsNil(o.HeaderTextId) {
		return true
	}

	return false
}

// SetHeaderTextId gets a reference to the given string and assigns it to the HeaderTextId field.
func (o *MessageData) SetHeaderTextId(v string) {
	o.HeaderTextId = &v
}

// GetTextId returns the TextId field value if set, zero value otherwise.
func (o *MessageData) GetTextId() string {
	if o == nil || IsNil(o.TextId) {
		var ret string
		return ret
	}
	return *o.TextId
}

// GetTextIdOk returns a tuple with the TextId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageData) GetTextIdOk() (*string, bool) {
	if o == nil || IsNil(o.TextId) {
		return nil, false
	}
	return o.TextId, true
}

// HasTextId returns a boolean if a field has been set.
func (o *MessageData) HasTextId() bool {
	if o != nil && !IsNil(o.TextId) {
		return true
	}

	return false
}

// SetTextId gets a reference to the given string and assigns it to the TextId field.
func (o *MessageData) SetTextId(v string) {
	o.TextId = &v
}

// GetFooterTextId returns the FooterTextId field value if set, zero value otherwise.
func (o *MessageData) GetFooterTextId() string {
	if o == nil || IsNil(o.FooterTextId) {
		var ret string
		return ret
	}
	return *o.FooterTextId
}

// GetFooterTextIdOk returns a tuple with the FooterTextId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageData) GetFooterTextIdOk() (*string, bool) {
	if o == nil || IsNil(o.FooterTextId) {
		return nil, false
	}
	return o.FooterTextId, true
}

// HasFooterTextId returns a boolean if a field has been set.
func (o *MessageData) HasFooterTextId() bool {
	if o != nil && !IsNil(o.FooterTextId) {
		return true
	}

	return false
}

// SetFooterTextId gets a reference to the given string and assigns it to the FooterTextId field.
func (o *MessageData) SetFooterTextId(v string) {
	o.FooterTextId = &v
}

// GetTemplate returns the Template field value if set, zero value otherwise.
func (o *MessageData) GetTemplate() string {
	if o == nil || IsNil(o.Template) {
		var ret string
		return ret
	}
	return *o.Template
}

// GetTemplateOk returns a tuple with the Template field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageData) GetTemplateOk() (*string, bool) {
	if o == nil || IsNil(o.Template) {
		return nil, false
	}
	return o.Template, true
}

// HasTemplate returns a boolean if a field has been set.
func (o *MessageData) HasTemplate() bool {
	if o != nil && !IsNil(o.Template) {
		return true
	}

	return false
}

// SetTemplate gets a reference to the given string and assigns it to the Template field.
func (o *MessageData) SetTemplate(v string) {
	o.Template = &v
}

// GetMedia returns the Media field value if set, zero value otherwise.
func (o *MessageData) GetMedia() MessageMedia {
	if o == nil || IsNil(o.Media) {
		var ret MessageMedia
		return ret
	}
	return *o.Media
}

// GetMediaOk returns a tuple with the Media field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageData) GetMediaOk() (*MessageMedia, bool) {
	if o == nil || IsNil(o.Media) {
		return nil, false
	}
	return o.Media, true
}

// HasMedia returns a boolean if a field has been set.
func (o *MessageData) HasMedia() bool {
	if o != nil && !IsNil(o.Media) {
		return true
	}

	return false
}

// SetMedia gets a reference to the given MessageMedia and assigns it to the Media field.
func (o *MessageData) SetMedia(v MessageMedia) {
	o.Media = &v
}

// GetButtons returns the Buttons field value if set, zero value otherwise.
func (o *MessageData) GetButtons() []MessageButton {
	if o == nil || IsNil(o.Buttons) {
		var ret []MessageButton
		return ret
	}
	return o.Buttons
}

// GetButtonsOk returns a tuple with the Buttons field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageData) GetButtonsOk() ([]MessageButton, bool) {
	if o == nil || IsNil(o.Buttons) {
		return nil, false
	}
	return o.Buttons, true
}

// HasButtons returns a boolean if a field has been set.
func (o *MessageData) HasButtons() bool {
	if o != nil && !IsNil(o.Buttons) {
		return true
	}

	return false
}

// SetButtons gets a reference to the given []MessageButton and assigns it to the Buttons field.
func (o *MessageData) SetButtons(v []MessageButton) {
	o.Buttons = v
}

// GetList returns the List field value if set, zero value otherwise.
func (o *MessageData) GetList() MessageList {
	if o == nil || IsNil(o.List) {
		var ret MessageList
		return ret
	}
	return *o.List
}

// GetListOk returns a tuple with the List field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageData) GetListOk() (*MessageList, bool) {
	if o == nil || IsNil(o.List) {
		return nil, false
	}
	return o.List, true
}

// HasList returns a boolean if a field has been set.
func (o *MessageData) HasList() bool {
	if o != nil && !IsNil(o.List) {
		return true
	}

	return false
}

// SetList gets a reference to the given MessageList and assigns it to the List field.
func (o *MessageData) SetList(v MessageList) {
	o.List = &v
}

// GetListName returns the ListName field value if set, zero value otherwise.
func (o *MessageData) GetListName() string {
	if o == nil || IsNil(o.ListName) {
		var ret string
		return ret
	}
	return *o.ListName
}

// GetListNameOk returns a tuple with the ListName field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageData) GetListNameOk() (*string, bool) {
	if o == nil || IsNil(o.ListName) {
		return nil, false
	}
	return o.ListName, true
}

// HasListName returns a boolean if a field has been set.
func (o *MessageData) HasListName() bool {
	if o != nil && !IsNil(o.ListName) {
		return true
	}

	return false
}

// SetListName gets a reference to the given string and assigns it to the ListName field.
func (o *MessageData) SetListName(v string) {
	o.ListName = &v
}

// GetRequestLocation returns the RequestLocation field value if set, zero value otherwise.
func (o *MessageData) GetRequestLocation() MessageRequestLocation {
	if o == nil || IsNil(o.RequestLocation) {
		var ret MessageRequestLocation
		return ret
	}
	return *o.RequestLocation
}

// GetRequestLocationOk returns a tuple with the RequestLocation field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageData) GetRequestLocationOk() (*MessageRequestLocation, bool) {
	if o == nil || IsNil(o.RequestLocation) {
		return nil, false
	}
	return o.RequestLocation, true
}

// HasRequestLocation returns a boolean if a field has been set.
func (o *MessageData) HasRequestLocation() bool {
	if o != nil && !IsNil(o.RequestLocation) {
		return true
	}

	return false
}

// SetRequestLocation gets a reference to the given MessageRequestLocation and assigns it to the RequestLocation field.
func (o *MessageData) SetRequestLocation(v MessageRequestLocation) {
	o.RequestLocation = &v
}

// GetCards returns the Cards field value if set, zero value otherwise.
func (o *MessageData) GetCards() []MessageData {
	if o == nil || IsNil(o.Cards) {
		var ret []MessageData
		return ret
	}
	return o.Cards
}

// GetCardsOk returns a tuple with the Cards field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *MessageData) GetCardsOk() ([]MessageData, bool) {
	if o == nil || IsNil(o.Cards) {
		return nil, false
	}
	return o.Cards, true
}

// HasCards returns a boolean if a field has been set.
func (o *MessageData) HasCards() bool {
	if o != nil && !IsNil(o.Cards) {
		return true
	}

	return false
}

// SetCards gets a reference to the given []MessageData and assigns it to the Cards field.
func (o *MessageData) SetCards(v []MessageData) {
	o.Cards = v
}

func (o MessageData) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o MessageData) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.HeaderTextId) {
		toSerialize["header_text_id"] = o.HeaderTextId
	}
	if !IsNil(o.TextId) {
		toSerialize["text_id"] = o.TextId
	}
	if !IsNil(o.FooterTextId) {
		toSerialize["footer_text_id"] = o.FooterTextId
	}
	if !IsNil(o.Template) {
		toSerialize["template"] = o.Template
	}
	if !IsNil(o.Media) {
		toSerialize["media"] = o.Media
	}
	if !IsNil(o.Buttons) {
		toSerialize["buttons"] = o.Buttons
	}
	if !IsNil(o.List) {
		toSerialize["list"] = o.List
	}
	if !IsNil(o.ListName) {
		toSerialize["list_name"] = o.ListName
	}
	if !IsNil(o.RequestLocation) {
		toSerialize["request_location"] = o.RequestLocation
	}
	if !IsNil(o.Cards) {
		toSerialize["cards"] = o.Cards
	}
	return toSerialize, nil
}

type NullableMessageData struct {
	value *MessageData
	isSet bool
}

func (v NullableMessageData) Get() *MessageData {
	return v.value
}

func (v *NullableMessageData) Set(val *MessageData) {
	v.value = val
	v.isSet = true
}

func (v NullableMessageData) IsSet() bool {
	return v.isSet
}

func (v *NullableMessageData) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableMessageData(val *MessageData) *NullableMessageData {
	return &NullableMessageData{value: val, isSet: true}
}

func (v NullableMessageData) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableMessageData) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


